from time import *

class Time:

    def __init__(self, hr=0, min=0, sec=0):
        if hr==0 and min==0 and sec==0:
            # get current local time from the system
            t = localtime()
            self.hr = t[3]
            self.min = t[4]
            self.sec = t[5]
        else:
            self.hr = hr
            self.min = min
            self.sec = sec

    def incrHr(self):
        self.hr += 1
        if self.hr >= 24:
            self.hr -= 24

    def incrMin(self):
        if self.min == 59:
            self.min = 0
            self.incrHr()
        else:
            self.min += 1

    def incrSec(self):
        if self.sec == 59:
            self.sec = 0
            self.incrMin()
        else:
            self.sec += 1

    def diff(self, alarm_time):
        curr_time_in_sec = ((self.hr * 60) + self.min) * 60 + self.sec
        #print curr_time_in_sec
        alarm_time_in_sec = ((alarm_time.hr * 60) + alarm_time.min) * 60 + alarm_time.sec
        #print alarm_time_in_sec
        if alarm_time_in_sec > curr_time_in_sec:
            return alarm_time_in_sec - curr_time_in_sec
        else:
            return alarm_time_in_sec + 24 * 3600 - curr_time_in_sec

    def __str__(self):
        if self.hr < 10:
            hrString = "0" + str(self.hr)
        else:
            hrString = str(self.hr)

        if self.min < 10:
            minString = "0" + str(self.min)
        else:
            minString = str(self.min)

        if self.sec < 10:
            secString = "0" + str(self.sec)
        else:
            secString = str(self.sec)
        return hrString + ":" + minString + ":" + secString

##if __name__=="__main__":
##    t = Time()
##    for i in range(60):
##        t.incrHr()
##        print str(t)
##        t.incrMin()
##        print str(t)
##        t.incrSec()
##        print str(t)
        

            
            
