# Python source code generated by SCC (StateChart Compiler) 0.1, written by Thomas Feng
#   Source: watchBehavior.des
#   Date:   April 6, 2004
#   Time:   13:4:15


# Header Section -- definition and module importation used by the following parts
import sys
import copy
import time
import string


class State:

  def __init__(self):

    self.StateID=-1
    self.Next=None


class History:

  def __init__(self):

    self.States=None
    self.Times=None
    self.Submodel=None


class EventList:

  def __init__(self):

    self.Event=None
    self.Next=None

  def Append(self, e):

    if isinstance(e, str):
      el=EventList()
      el.Event=e
      cur=this
      while cur.Next!=None and cur.Event!=e:
        cur=cur.Next;
      if cur.Event!=e:
        cur.Next=el

    elif isinstance(e, EventList):
      el=e
      while el!=None:
        self.Append(el.Event)
        el=el.Next


class StringList:

  def __init__(self, str=""):

    self.str=str
    self.Next=None


class IntList:

  def __init__(self, int=0):

    self.int=int
    self.Next=None


class Hierarchy:

  def __init__(self):

    self.StateName=None
    self.PathName=None
    self.StateNum=-1
    self.Level=-1
    self.Next=None


# Scheduler for timed transitions (used only when --ext is set)
import thread
import time
class Scheduler:

  def __init__(self, model, event, interval, repeat):

    self.Model=model
    self.Event=event
    self.Interval=interval
    self.Repeat=repeat
    self.Lock=thread.allocate_lock()
    self.Stopped=0
    self.Next=None

  def start(self):

    thread.start_new_thread(self.run, ())

  def stop(self):

    self.Lock.acquire()
    self.Stopped=1
    self.Lock.release()

  def clear(self):

    self.stop()
    if self.Next:
      self.Next.clear()

  def run(self):

    stopped=0
    while not stopped:
      time.sleep(self.Interval)
      self.Lock.acquire()
      stopped=self.Stopped
      self.Lock.release()
      if not stopped:
        self.Model.event(self.Event, [], None, 0)
        stopped=not self.Repeat


class StateMachine:

  def eventStr2Int(self, event):

    return -1

  def getCurrentStateList(self):

    return None

  def getCurrentState(self):

    return "[]"

  def getEnabledEvents(self):

    return None

  def initModel(self, run_initializer=1, run_enter_actions=1):

    pass

  def isInState(self, s):

    return 0

  def getParentState(self, state):

    return -1

  def isHistoryState(self, state):

    return 0

  def isLeafState(self, state):

    return 0

  def getHierarchy(self, start_level=0, state_prefix=None):

    return None

  def topLevelHistory(self):

    pass

  def recordAllEnteredStates(self):

    pass

  def runAllEnterActions(self):

    pass

  def runInitializer(self):

    pass

  def runFinalizer(self):

    pass

  def runInteractor(self):

    pass

  def state(self):

    pass

  def handleEvent(self, se, params=[], lock=None, call_submodels=1):

    return 0

  def event(self, e, params=[], lock=None, call_submodels=1):

    pass


def startswith(s, ss):

  return ss==None or (s!=None and len(s)>=len(ss) and s[0:len(ss)]==ss)


# used only when --ext is set
from code import InteractiveInterpreter


# Main Class -- the top level model that is executed from the command line
class watchBehavior(StateMachine):

  # Constants for this model
  StateNum=27
  EventNames=["ALARM-OFF",
              "ALARM-ON",
              "A_PRESS",
              "B_PRESS",
              "C_PRESS",
              "C_RELEASE",
              "D_PRESS",
              "RESET",
              "TIME-OFF",
              "TIME-ON",
              "TURN_OFF",
              "TURN_ON",
              "__INTERNAL_0_TIME_0",
              "__INTERNAL_0_TIME_1",
              "__INTERNAL_0_TIME_2",
              "__INTERNAL_0_TIME_3",
              "__INTERNAL_0_TIME_4",
              "__INTERNAL_0_TIME_5",
              "__INTERNAL_0_TIME_6" 
             ]
  StateNames=["ALARM_BEEP",
              "ALARM_BEEP.BEEP",
              "ALARM_BEEP.BEEP.BEEP_DELAY",
              "ALARM_BEEP.BEEP.BEEP_OFF",
              "ALARM_BEEP.BEEP.BEEP_ON",
              "ALARM_STATUS",
              "ALARM_STATUS.DISABLE",
              "ALARM_STATUS.ENABLE",
              "BEEP_STATUS",
              "BEEP_STATUS.BEEPING_OFF",
              "BEEP_STATUS.BEEPING_ON",
              "DISPLAY",
              "DISPLAY.ALARM",
              "DISPLAY.ALARM.OFF",
              "DISPLAY.ALARM.ON",
              "DISPLAY.TIME",
              "DISPLAY.UPDATE_ALARM",
              "DISPLAY.UPDATE_ALARM.ALARM_HR",
              "DISPLAY.UPDATE_ALARM.ALARM_MIN",
              "DISPLAY.UPDATE_TIME",
              "DISPLAY.UPDATE_TIME.HR",
              "DISPLAY.UPDATE_TIME.MIN",
              "DISPLAY.UPDATE_TIME.SEC",
              "DISPLAY.WAIT",
              "TIME_GEN",
              "TIME_GEN.TIME_GEN_OFF",
              "TIME_GEN.TIME_GEN_ON" 
             ]
  ParentTable=[-1,  # ALARM_BEEP -- parent (None)
               0,  # ALARM_BEEP.BEEP -- parent ALARM_BEEP
               1,  # ALARM_BEEP.BEEP.BEEP_DELAY -- parent ALARM_BEEP.BEEP
               1,  # ALARM_BEEP.BEEP.BEEP_OFF -- parent ALARM_BEEP.BEEP
               1,  # ALARM_BEEP.BEEP.BEEP_ON -- parent ALARM_BEEP.BEEP
               -1,  # ALARM_STATUS -- parent (None)
               5,  # ALARM_STATUS.DISABLE -- parent ALARM_STATUS
               5,  # ALARM_STATUS.ENABLE -- parent ALARM_STATUS
               -1,  # BEEP_STATUS -- parent (None)
               8,  # BEEP_STATUS.BEEPING_OFF -- parent BEEP_STATUS
               8,  # BEEP_STATUS.BEEPING_ON -- parent BEEP_STATUS
               -1,  # DISPLAY -- parent (None)
               11,  # DISPLAY.ALARM -- parent DISPLAY
               12,  # DISPLAY.ALARM.OFF -- parent DISPLAY.ALARM
               12,  # DISPLAY.ALARM.ON -- parent DISPLAY.ALARM
               11,  # DISPLAY.TIME -- parent DISPLAY
               11,  # DISPLAY.UPDATE_ALARM -- parent DISPLAY
               16,  # DISPLAY.UPDATE_ALARM.ALARM_HR -- parent DISPLAY.UPDATE_ALARM
               16,  # DISPLAY.UPDATE_ALARM.ALARM_MIN -- parent DISPLAY.UPDATE_ALARM
               11,  # DISPLAY.UPDATE_TIME -- parent DISPLAY
               19,  # DISPLAY.UPDATE_TIME.HR -- parent DISPLAY.UPDATE_TIME
               19,  # DISPLAY.UPDATE_TIME.MIN -- parent DISPLAY.UPDATE_TIME
               19,  # DISPLAY.UPDATE_TIME.SEC -- parent DISPLAY.UPDATE_TIME
               11,  # DISPLAY.WAIT -- parent DISPLAY
               -1,  # TIME_GEN -- parent (None)
               24,  # TIME_GEN.TIME_GEN_OFF -- parent TIME_GEN
               24   # TIME_GEN.TIME_GEN_ON -- parent TIME_GEN
              ]
  HistoryStateTable=[0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     1,
                     0,
                     0,
                     0,
                     1,
                     0,
                     0,
                     1,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0 
                    ]
  LeafStateTable=[None,
                  None,
                  "ALARM_BEEP.BEEP.BEEP_DELAY",
                  "ALARM_BEEP.BEEP.BEEP_OFF",
                  "ALARM_BEEP.BEEP.BEEP_ON",
                  None,
                  "ALARM_STATUS.DISABLE",
                  "ALARM_STATUS.ENABLE",
                  None,
                  "BEEP_STATUS.BEEPING_OFF",
                  "BEEP_STATUS.BEEPING_ON",
                  None,
                  None,
                  "DISPLAY.ALARM.OFF",
                  "DISPLAY.ALARM.ON",
                  "DISPLAY.TIME",
                  None,
                  "DISPLAY.UPDATE_ALARM.ALARM_HR",
                  "DISPLAY.UPDATE_ALARM.ALARM_MIN",
                  None,
                  "DISPLAY.UPDATE_TIME.HR",
                  "DISPLAY.UPDATE_TIME.MIN",
                  "DISPLAY.UPDATE_TIME.SEC",
                  "DISPLAY.WAIT",
                  None,
                  "TIME_GEN.TIME_GEN_OFF",
                  "TIME_GEN.TIME_GEN_ON" 
                 ]
  OrthogonalInBetween=[[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] 
                      ]
  Hierarchy=[[0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_BEEP
             [0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_BEEP.BEEP
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_BEEP.BEEP.BEEP_DELAY
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_BEEP.BEEP.BEEP_OFF
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_BEEP.BEEP.BEEP_ON
             [0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_STATUS
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_STATUS.DISABLE
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state ALARM_STATUS.ENABLE
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state BEEP_STATUS
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state BEEP_STATUS.BEEPING_OFF
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state BEEP_STATUS.BEEPING_ON
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0],  # substates of state DISPLAY
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.ALARM
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.ALARM.OFF
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.ALARM.ON
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.TIME
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_ALARM
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_ALARM.ALARM_HR
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_ALARM.ALARM_MIN
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_TIME
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_TIME.HR
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_TIME.MIN
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.UPDATE_TIME.SEC
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state DISPLAY.WAIT
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1],  # substates of state TIME_GEN
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state TIME_GEN.TIME_GEN_OFF
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]   # substates of state TIME_GEN.TIME_GEN_ON
            ]
  CommonStateTable=[[-1, 0, 0, 0, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [0, 0, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [0, 1, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [0, 1, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [0, 1, 1, 1, 1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, 5, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, 5, 5, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, 5, 5, 5, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, 8, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, 8, 8, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, 8, 8, 8, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 12, 12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 12, 12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 16, 16, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 16, 16, 16, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 16, 16, 16, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, 19, 19, 19, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 19, 19, 19, 19, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 19, 19, 19, 19, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 19, 19, 19, 19, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 24, 24],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 24, 24, 24],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 24, 24, 24] 
                   ]
  Description=None

  Lock=thread.allocate_lock()
  CurrentModel=None

  def __init__(self, Interpreter=None):

    # Variables
    self.state=None
    self.Submodels=[]
    for i in range(watchBehavior.StateNum):
      self.Submodels.append(None)
    self.history=[]
    for i in range(watchBehavior.StateNum):
      self.history.append(None)

    # Constructor
    for i in range(watchBehavior.StateNum):
      self.history[i]=History()
      self.history[i].States=[]
      self.history[i].Times=[]
      for j in range(watchBehavior.StateNum):
        self.history[i].States.append(-1)
        self.history[i].Times.append(-1)

    self.TimedTransitions=[] # used only when --ext is set
    for i in range(watchBehavior.StateNum):
      self.TimedTransitions.append(None)

    self.clearEnteredStates()

    # Interpreter of action code
    if Interpreter:
      self.DefaultInterpreter=Interpreter
    else:
      self.DefaultInterpreter=InteractiveInterpreter()
    self.HasInteractor=0
    self.setupInterpreter()

    self.EventsLock=thread.allocate_lock()
    self.PendingEvents=None
    self.PendingEventsTail=None
    self.HandleEventRunning=0
    self.Started=0

    self.description=watchBehavior.Description

  # Methods
  def isParent(self, sp, sc):

    return sc>=0 and (sp<0 or watchBehavior.Hierarchy[sp][sc])

  def isInState(self, s):

    if isinstance(s, int):
      st=self.state
      while st!=None:
        if st.StateID==s or self.isParent(s, st.StateID):
          return 1
        else:
          st=st.Next
      return 0

    elif isinstance(s, str):
      for i in range(watchBehavior.StateNum):
        if s==watchBehavior.StateNames[i]:
          return self.isInState(i)
      for i in range(watchBehavior.StateNum):
        if self.Submodels[i]!=None and startsWith(s, watchBehavior.StateNames[i]+"."):
          SubmodelState=s[len(watchBehavior.StateNames[i])+1:]
          return self.isInState(i) and self.Submodels[i].isInState(SubmodelState)
    return 0

  def main(self, argv):

    model=watchBehavior()
    cmd=""
    model.initModel()
    if model.HasInteractor:
      model.runInteractor()
    else:
      if watchBehavior.Description:
        sys.__stdout__.write(watchBehavior.Description+"\n")
      lock=thread.allocate_lock()
      while cmd!="exit":
        sys.__stdout__.write(model.getCurrentState()+" > ")
        cmd=string.strip(sys.__stdin__.readline())
        if cmd=="exit":
          break
        lock.acquire()
        model.event(cmd, [], lock)
        lock.acquire()
        lock.release()
    model.runFinalizer()

  def initModel(self, run_initializer=1, run_enter_actions=1):

    self.clearEnteredStates()
    self.addInState(3) # init state "ALARM_BEEP.BEEP.BEEP_OFF"
    self.recordEnteredState(0)
    self.recordEnteredState(1)
    self.recordEnteredState(3)
    self.addInState(6) # init state "ALARM_STATUS.DISABLE"
    self.recordEnteredState(5)
    self.recordEnteredState(6)
    self.addInState(9) # init state "BEEP_STATUS.BEEPING_OFF"
    self.recordEnteredState(8)
    self.recordEnteredState(9)
    self.addInState(15) # init state "DISPLAY.TIME"
    self.recordEnteredState(11)
    self.recordEnteredState(15)
    self.addInState(26) # init state "TIME_GEN.TIME_GEN_ON"
    self.recordEnteredState(24)
    self.recordEnteredState(26)
    if run_initializer:
      self.runInitializer()
    if not self.HasInteractor:
      self.start(None, run_enter_actions)

  def handleEvent(self, se, params=[], lock=None, call_submodels=1):

    if not self.Started:
      if lock:
        lock.release()
      return 0
    self.EventsLock.acquire()
    self.HandleEventRunning=1
    self.EventsLock.release()
    self.params=params
    e=self.eventStr2Int(se)
    if e==0: # event "ALARM-OFF"
      if self.isInState(7) and self.testCondition(0):
        self.runExitActionsForStates(5)
	self.clearEnteredStates()
        self.changeState(7, 6)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==1: # event "ALARM-ON"
      if self.isInState(6) and self.testCondition(1):
        self.runExitActionsForStates(5)
	self.clearEnteredStates()
        self.changeState(6, 7)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==2: # event "A_PRESS"
      if self.isInState(12) and self.testCondition(2):
        self.runActionCode(2) # output action(s)
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(12, 15)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(15) and self.testCondition(3):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(15, 12, 1)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==3: # event "B_PRESS"
      if self.isInState(16) and self.testCondition(4):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(16, 12, 1)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(5):
        self.runActionCode(3) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(4, 3)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==4: # event "C_PRESS"
      if self.isInState(22) and self.testCondition(6):
        self.runExitActionsForStates(19)
	self.clearEnteredStates()
        self.changeState(22, 21)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(21) and self.testCondition(7):
        self.runExitActionsForStates(19)
	self.clearEnteredStates()
        self.changeState(21, 20)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(17) and self.testCondition(8):
        self.runExitActionsForStates(16)
	self.clearEnteredStates()
        self.changeState(17, 18)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(12) and self.testCondition(9):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(12, 16)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(20) and self.testCondition(10):
        self.runActionCode(4) # output action(s)
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(20, 15)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(15) and self.testCondition(11):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(15, 23)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(18) and self.testCondition(12):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(18, 12, 1)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==5: # event "C_RELEASE"
      if self.isInState(23) and self.testCondition(13):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(23, 15)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==6: # event "D_PRESS"
      if self.isInState(22) and self.testCondition(14):
        self.runActionCode(5) # output action(s)
        self.runExitActionsForStates(19)
	self.clearEnteredStates()
        self.changeState(22, 22)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(21) and self.testCondition(15):
        self.runActionCode(6) # output action(s)
        self.runExitActionsForStates(19)
	self.clearEnteredStates()
        self.changeState(21, 21)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(20) and self.testCondition(16):
        self.runActionCode(7) # output action(s)
        self.runExitActionsForStates(19)
	self.clearEnteredStates()
        self.changeState(20, 20)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(13) and self.testCondition(17):
        self.runActionCode(8) # output action(s)
        self.runExitActionsForStates(12)
	self.clearEnteredStates()
        self.changeState(13, 14)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(14) and self.testCondition(18):
        self.runActionCode(9) # output action(s)
        self.runExitActionsForStates(12)
	self.clearEnteredStates()
        self.changeState(14, 13)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(18) and self.testCondition(19):
        self.runActionCode(10) # output action(s)
        self.runExitActionsForStates(16)
	self.clearEnteredStates()
        self.changeState(18, 18)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(17) and self.testCondition(20):
        self.runActionCode(11) # output action(s)
        self.runExitActionsForStates(16)
	self.clearEnteredStates()
        self.changeState(17, 17)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==7: # event "RESET"
      if self.isInState(1) and self.testCondition(21):
        self.runActionCode(12) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(1, 2)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(1) and self.testCondition(22):
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(1, 3)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==8: # event "TIME-OFF"
      if self.isInState(26) and self.testCondition(23):
        self.runActionCode(13) # output action(s)
        self.runExitActionsForStates(24)
	self.clearEnteredStates()
        self.changeState(26, 25)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==9: # event "TIME-ON"
      if self.isInState(25) and self.testCondition(24):
        self.runActionCode(14) # output action(s)
        self.runExitActionsForStates(24)
	self.clearEnteredStates()
        self.changeState(25, 26)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==10: # event "TURN_OFF"
      if self.isInState(10) and self.testCondition(25):
        self.runActionCode(15) # output action(s)
        self.runExitActionsForStates(8)
	self.clearEnteredStates()
        self.changeState(10, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==11: # event "TURN_ON"
      if self.isInState(9) and self.testCondition(26):
        self.runExitActionsForStates(8)
	self.clearEnteredStates()
        self.changeState(9, 10)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==12: # event "__INTERNAL_0_TIME_0"
      if self.isInState(12) and self.testCondition(27):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(12, 12, 1)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==13: # event "__INTERNAL_0_TIME_1"
      if self.isInState(15) and self.testCondition(28):
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(15, 15)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==14: # event "__INTERNAL_0_TIME_2"
      if self.isInState(23) and self.testCondition(29):
        self.runActionCode(16) # output action(s)
        self.runExitActionsForStates(11)
	self.clearEnteredStates()
        self.changeState(23, 19)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==15: # event "__INTERNAL_0_TIME_3"
      if self.isInState(26) and self.testCondition(30):
        self.runActionCode(17) # output action(s)
        self.runExitActionsForStates(24)
	self.clearEnteredStates()
        self.changeState(26, 26)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==16: # event "__INTERNAL_0_TIME_4"
      if self.isInState(10) and self.testCondition(31):
        self.runActionCode(18) # output action(s)
        self.runExitActionsForStates(8)
	self.clearEnteredStates()
        self.changeState(10, 10)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==17: # event "__INTERNAL_0_TIME_5"
      if self.isInState(2) and self.testCondition(32):
        self.runActionCode(19) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==18: # event "__INTERNAL_0_TIME_6"
      if self.isInState(4) and self.testCondition(33):
        self.runActionCode(20) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(4, 3)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    if lock:
      lock.release()
    self.checkPendingEvents()
    return 0

  def forceIntoState(self, s):

    changed=0
    s2=self.state
    while s2!=None:
      HasCommonParent=0
      for i in range(watchBehavior.StateNum):
        if self.isParent(i, s2.StateID) and self.isParent(i, s):
          HasCommonParent=1
          if not self.hasOrthogonalStateInBetween(i, s2.StateID):
            self.changeState(s2.StateID, s)
            changed=1
      if not HasCommonParent:
        self.changeState(s2.StateID, s)
        changed=1
      s2=s2.Next
    if not changed:
      self.addInState(s)

  def changeState(self, s1, s2, check_history=0, top_level=0):

    # t1=common(s1, s2)
    t1=watchBehavior.CommonStateTable[s1][s2]
    self.recordHistory(t1)
    if t1>=0:
      self.removeOutStates(t1)
    else:
      self.state=None
    # t2=history(s2)
    t2=watchBehavior.HistoryStateTable[s2]
    if t2==0: # no history
      self.generateStates(t1, s2)
    elif t2==1: # normal history
      if not check_history:
        self.generateStates(t1, s2)
      elif self.hasHistoryRecorded(s2):
        self.generateStates(t1, self.history[s2].States[s2])
      else:
        self.generateStates(t1, s2, 1)
    elif t2==2: # deep history
      if check_history and self.hasHistoryRecorded(s2):
        for i in range(watchBehavior.StateNum):
          hs=self.history[s2].States[i]
          if hs>=0 and self.isLeafState(hs):
            # used only when --ext is set
            self.recordEnteredState(hs, 1, 1, t1)
            self.addInState(hs)
      else:
        self.generateStates(t1, s2)

  def addInState(self, s):

    if not self.isInState(s):
      st=State()
      st.StateID=s
      st.Next=self.state
      self.state=st
      return 1
    else:
      return 0

  def generateStates(self, common, dest, history_type=0):

    if common==-1:
      if dest==0:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==1:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==2:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                self.addInState(2)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_DELAY"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==3:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==4:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_ON"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==5:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==6:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==7:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(7):
              self.recordEnteredState(7)
              self.addInState(7)  # move into leaf state "ALARM_STATUS.ENABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==8:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==9:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==10:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              self.addInState(10)  # move into leaf state "BEEP_STATUS.BEEPING_ON"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==11:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==12:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(12):
              self.recordEnteredState(12)
              if history_type!=2 or self.check_history(13):
                self.recordEnteredState(13)
                self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==13:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(12):
              self.recordEnteredState(12)
              if history_type!=2 or self.check_history(13):
                self.recordEnteredState(13)
                self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==14:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(12):
              self.recordEnteredState(12)
              if history_type!=2 or self.check_history(14):
                self.recordEnteredState(14)
                self.addInState(14)  # move into leaf state "DISPLAY.ALARM.ON"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==15:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==16:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(16):
              self.recordEnteredState(16)
              if history_type!=2 or self.check_history(17):
                self.recordEnteredState(17)
                self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==17:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(16):
              self.recordEnteredState(16)
              if history_type!=2 or self.check_history(17):
                self.recordEnteredState(17)
                self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==18:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(16):
              self.recordEnteredState(16)
              if history_type!=2 or self.check_history(18):
                self.recordEnteredState(18)
                self.addInState(18)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_MIN"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==19:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(19):
              self.recordEnteredState(19)
              if history_type!=2 or self.check_history(22):
                self.recordEnteredState(22)
                self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==20:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(19):
              self.recordEnteredState(19)
              if history_type!=2 or self.check_history(20):
                self.recordEnteredState(20)
                self.addInState(20)  # move into leaf state "DISPLAY.UPDATE_TIME.HR"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==21:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(19):
              self.recordEnteredState(19)
              if history_type!=2 or self.check_history(21):
                self.recordEnteredState(21)
                self.addInState(21)  # move into leaf state "DISPLAY.UPDATE_TIME.MIN"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==22:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(19):
              self.recordEnteredState(19)
              if history_type!=2 or self.check_history(22):
                self.recordEnteredState(22)
                self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==23:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(23):
              self.recordEnteredState(23)
              self.addInState(23)  # move into leaf state "DISPLAY.WAIT"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==24:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==25:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(25):
              self.recordEnteredState(25)
              self.addInState(25)  # move into leaf state "TIME_GEN.TIME_GEN_OFF"
      elif dest==26:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            if history_type!=2 or self.check_history(15):
              self.recordEnteredState(15)
              self.addInState(15)  # move into leaf state "DISPLAY.TIME"
          if history_type!=2 or self.check_history(24):
            self.recordEnteredState(24)
            if history_type!=2 or self.check_history(26):
              self.recordEnteredState(26)
              self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
    elif common==0:
      if dest==0:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
      elif dest==1:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
      elif dest==2:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              self.addInState(2)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_DELAY"
      elif dest==3:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
      elif dest==4:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_ON"
    elif common==1:
      if dest==1:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
      elif dest==2:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            self.addInState(2)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_DELAY"
      elif dest==3:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
      elif dest==4:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(4):
            self.recordEnteredState(4)
            self.addInState(4)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_ON"
    elif common==2:
      if dest==2:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          self.addInState(2)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_DELAY"
    elif common==3:
      if dest==3:
        if history_type!=2 or self.check_history(3):
          self.recordEnteredState(3)
          self.addInState(3)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_OFF"
    elif common==4:
      if dest==4:
        if history_type!=2 or self.check_history(4):
          self.recordEnteredState(4)
          self.addInState(4)  # move into leaf state "ALARM_BEEP.BEEP.BEEP_ON"
    elif common==5:
      if dest==5:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(6):
            self.recordEnteredState(6)
            self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
      elif dest==6:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(6):
            self.recordEnteredState(6)
            self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
      elif dest==7:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(7):
            self.recordEnteredState(7)
            self.addInState(7)  # move into leaf state "ALARM_STATUS.ENABLE"
    elif common==6:
      if dest==6:
        if history_type!=2 or self.check_history(6):
          self.recordEnteredState(6)
          self.addInState(6)  # move into leaf state "ALARM_STATUS.DISABLE"
    elif common==7:
      if dest==7:
        if history_type!=2 or self.check_history(7):
          self.recordEnteredState(7)
          self.addInState(7)  # move into leaf state "ALARM_STATUS.ENABLE"
    elif common==8:
      if dest==8:
        if history_type!=2 or self.check_history(8):
          self.recordEnteredState(8)
          if history_type!=2 or self.check_history(9):
            self.recordEnteredState(9)
            self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
      elif dest==9:
        if history_type!=2 or self.check_history(8):
          self.recordEnteredState(8)
          if history_type!=2 or self.check_history(9):
            self.recordEnteredState(9)
            self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
      elif dest==10:
        if history_type!=2 or self.check_history(8):
          self.recordEnteredState(8)
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            self.addInState(10)  # move into leaf state "BEEP_STATUS.BEEPING_ON"
    elif common==9:
      if dest==9:
        if history_type!=2 or self.check_history(9):
          self.recordEnteredState(9)
          self.addInState(9)  # move into leaf state "BEEP_STATUS.BEEPING_OFF"
    elif common==10:
      if dest==10:
        if history_type!=2 or self.check_history(10):
          self.recordEnteredState(10)
          self.addInState(10)  # move into leaf state "BEEP_STATUS.BEEPING_ON"
    elif common==11:
      if dest==11:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(15):
            self.recordEnteredState(15)
            self.addInState(15)  # move into leaf state "DISPLAY.TIME"
      elif dest==12:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(12):
            self.recordEnteredState(12)
            if history_type!=2 or self.check_history(13):
              self.recordEnteredState(13)
              self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
      elif dest==13:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(12):
            self.recordEnteredState(12)
            if history_type!=2 or self.check_history(13):
              self.recordEnteredState(13)
              self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
      elif dest==14:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(12):
            self.recordEnteredState(12)
            if history_type!=2 or self.check_history(14):
              self.recordEnteredState(14)
              self.addInState(14)  # move into leaf state "DISPLAY.ALARM.ON"
      elif dest==15:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(15):
            self.recordEnteredState(15)
            self.addInState(15)  # move into leaf state "DISPLAY.TIME"
      elif dest==16:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(16):
            self.recordEnteredState(16)
            if history_type!=2 or self.check_history(17):
              self.recordEnteredState(17)
              self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
      elif dest==17:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(16):
            self.recordEnteredState(16)
            if history_type!=2 or self.check_history(17):
              self.recordEnteredState(17)
              self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
      elif dest==18:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(16):
            self.recordEnteredState(16)
            if history_type!=2 or self.check_history(18):
              self.recordEnteredState(18)
              self.addInState(18)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_MIN"
      elif dest==19:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(19):
            self.recordEnteredState(19)
            if history_type!=2 or self.check_history(22):
              self.recordEnteredState(22)
              self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
      elif dest==20:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(19):
            self.recordEnteredState(19)
            if history_type!=2 or self.check_history(20):
              self.recordEnteredState(20)
              self.addInState(20)  # move into leaf state "DISPLAY.UPDATE_TIME.HR"
      elif dest==21:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(19):
            self.recordEnteredState(19)
            if history_type!=2 or self.check_history(21):
              self.recordEnteredState(21)
              self.addInState(21)  # move into leaf state "DISPLAY.UPDATE_TIME.MIN"
      elif dest==22:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(19):
            self.recordEnteredState(19)
            if history_type!=2 or self.check_history(22):
              self.recordEnteredState(22)
              self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
      elif dest==23:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          if history_type!=2 or self.check_history(23):
            self.recordEnteredState(23)
            self.addInState(23)  # move into leaf state "DISPLAY.WAIT"
    elif common==12:
      if dest==12:
        if history_type!=2 or self.check_history(12):
          self.recordEnteredState(12)
          if history_type!=2 or self.check_history(13):
            self.recordEnteredState(13)
            self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
      elif dest==13:
        if history_type!=2 or self.check_history(12):
          self.recordEnteredState(12)
          if history_type!=2 or self.check_history(13):
            self.recordEnteredState(13)
            self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
      elif dest==14:
        if history_type!=2 or self.check_history(12):
          self.recordEnteredState(12)
          if history_type!=2 or self.check_history(14):
            self.recordEnteredState(14)
            self.addInState(14)  # move into leaf state "DISPLAY.ALARM.ON"
    elif common==13:
      if dest==13:
        if history_type!=2 or self.check_history(13):
          self.recordEnteredState(13)
          self.addInState(13)  # move into leaf state "DISPLAY.ALARM.OFF"
    elif common==14:
      if dest==14:
        if history_type!=2 or self.check_history(14):
          self.recordEnteredState(14)
          self.addInState(14)  # move into leaf state "DISPLAY.ALARM.ON"
    elif common==15:
      if dest==15:
        if history_type!=2 or self.check_history(15):
          self.recordEnteredState(15)
          self.addInState(15)  # move into leaf state "DISPLAY.TIME"
    elif common==16:
      if dest==16:
        if history_type!=2 or self.check_history(16):
          self.recordEnteredState(16)
          if history_type!=2 or self.check_history(17):
            self.recordEnteredState(17)
            self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
      elif dest==17:
        if history_type!=2 or self.check_history(16):
          self.recordEnteredState(16)
          if history_type!=2 or self.check_history(17):
            self.recordEnteredState(17)
            self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
      elif dest==18:
        if history_type!=2 or self.check_history(16):
          self.recordEnteredState(16)
          if history_type!=2 or self.check_history(18):
            self.recordEnteredState(18)
            self.addInState(18)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_MIN"
    elif common==17:
      if dest==17:
        if history_type!=2 or self.check_history(17):
          self.recordEnteredState(17)
          self.addInState(17)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_HR"
    elif common==18:
      if dest==18:
        if history_type!=2 or self.check_history(18):
          self.recordEnteredState(18)
          self.addInState(18)  # move into leaf state "DISPLAY.UPDATE_ALARM.ALARM_MIN"
    elif common==19:
      if dest==19:
        if history_type!=2 or self.check_history(19):
          self.recordEnteredState(19)
          if history_type!=2 or self.check_history(22):
            self.recordEnteredState(22)
            self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
      elif dest==20:
        if history_type!=2 or self.check_history(19):
          self.recordEnteredState(19)
          if history_type!=2 or self.check_history(20):
            self.recordEnteredState(20)
            self.addInState(20)  # move into leaf state "DISPLAY.UPDATE_TIME.HR"
      elif dest==21:
        if history_type!=2 or self.check_history(19):
          self.recordEnteredState(19)
          if history_type!=2 or self.check_history(21):
            self.recordEnteredState(21)
            self.addInState(21)  # move into leaf state "DISPLAY.UPDATE_TIME.MIN"
      elif dest==22:
        if history_type!=2 or self.check_history(19):
          self.recordEnteredState(19)
          if history_type!=2 or self.check_history(22):
            self.recordEnteredState(22)
            self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
    elif common==20:
      if dest==20:
        if history_type!=2 or self.check_history(20):
          self.recordEnteredState(20)
          self.addInState(20)  # move into leaf state "DISPLAY.UPDATE_TIME.HR"
    elif common==21:
      if dest==21:
        if history_type!=2 or self.check_history(21):
          self.recordEnteredState(21)
          self.addInState(21)  # move into leaf state "DISPLAY.UPDATE_TIME.MIN"
    elif common==22:
      if dest==22:
        if history_type!=2 or self.check_history(22):
          self.recordEnteredState(22)
          self.addInState(22)  # move into leaf state "DISPLAY.UPDATE_TIME.SEC"
    elif common==23:
      if dest==23:
        if history_type!=2 or self.check_history(23):
          self.recordEnteredState(23)
          self.addInState(23)  # move into leaf state "DISPLAY.WAIT"
    elif common==24:
      if dest==24:
        if history_type!=2 or self.check_history(24):
          self.recordEnteredState(24)
          if history_type!=2 or self.check_history(26):
            self.recordEnteredState(26)
            self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
      elif dest==25:
        if history_type!=2 or self.check_history(24):
          self.recordEnteredState(24)
          if history_type!=2 or self.check_history(25):
            self.recordEnteredState(25)
            self.addInState(25)  # move into leaf state "TIME_GEN.TIME_GEN_OFF"
      elif dest==26:
        if history_type!=2 or self.check_history(24):
          self.recordEnteredState(24)
          if history_type!=2 or self.check_history(26):
            self.recordEnteredState(26)
            self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"
    elif common==25:
      if dest==25:
        if history_type!=2 or self.check_history(25):
          self.recordEnteredState(25)
          self.addInState(25)  # move into leaf state "TIME_GEN.TIME_GEN_OFF"
    elif common==26:
      if dest==26:
        if history_type!=2 or self.check_history(26):
          self.recordEnteredState(26)
          self.addInState(26)  # move into leaf state "TIME_GEN.TIME_GEN_ON"

  def removeOutStates(self, common_state):

    s=self.state
    prev=None
    while s!=None:
      if self.isParent(common_state, s.StateID):
        if prev==None:
          self.state=self.state.Next
        else:
          prev.Next=s.Next
      else:
        prev=s
      s=s.Next

  def eventStr2Int(self, event):

    for i in range(19):
      if event==watchBehavior.EventNames[i]:
        return i
    return -1

  def stateInt2Str(self, state):

    if state==-1:
      return ""
    else:
      return watchBehavior.StateNames[state]

  def getCurrentStateList(self):

    sl=StringList()
    slend=sl
    s=self.state
    while s!=None:
      sm=self.Submodels[s.StateID]
      curstate=self.stateInt2Str(s.StateID)
      if sm!=None:
        slend.Next=sm.getCurrentStateList()
        while slend.Next!=None:
          slend.Next.str=curstate+"."+slend.Next.str
          slend=slend.Next
      else:
        slend.Next=StringList(curstate)
        slend=slend.Next
      s=s.Next
    return sl.Next

  def getCurrentState(self, states=None):

    if states==None:
      states=self.getCurrentStateList()
      if states!=None:
        strst="[%s'%s']" % (self.getCurrentState(states), states.str)
      else:
        strst="[]"
    else:
      if states.Next:
        strst="%s'%s', " % (self.getCurrentState(states.Next), states.Next.str)
      else:
        strst=""
    return strst

  def getParentState(self, state):

    return watchBehavior.ParentTable[state]

  def getSubstates(self, state):

    substates=None
    if state==-1: # substates of ""
      # add substate "ALARM_BEEP"
      st=IntList()
      st.int=0
      st.Next=substates
      substates=st
      # add substate "ALARM_STATUS"
      st=IntList()
      st.int=5
      st.Next=substates
      substates=st
      # add substate "BEEP_STATUS"
      st=IntList()
      st.int=8
      st.Next=substates
      substates=st
      # add substate "DISPLAY"
      st=IntList()
      st.int=11
      st.Next=substates
      substates=st
      # add substate "TIME_GEN"
      st=IntList()
      st.int=24
      st.Next=substates
      substates=st
    elif state==0: # substates of "ALARM_BEEP"
      # add substate "ALARM_BEEP.BEEP"
      st=IntList()
      st.int=1
      st.Next=substates
      substates=st
    elif state==1: # substates of "ALARM_BEEP.BEEP"
      # add substate "ALARM_BEEP.BEEP.BEEP_DELAY"
      st=IntList()
      st.int=2
      st.Next=substates
      substates=st
      # add substate "ALARM_BEEP.BEEP.BEEP_OFF"
      st=IntList()
      st.int=3
      st.Next=substates
      substates=st
      # add substate "ALARM_BEEP.BEEP.BEEP_ON"
      st=IntList()
      st.int=4
      st.Next=substates
      substates=st
    elif state==2: # substates of "ALARM_BEEP.BEEP.BEEP_DELAY"
      pass
    elif state==3: # substates of "ALARM_BEEP.BEEP.BEEP_OFF"
      pass
    elif state==4: # substates of "ALARM_BEEP.BEEP.BEEP_ON"
      pass
    elif state==5: # substates of "ALARM_STATUS"
      # add substate "ALARM_STATUS.DISABLE"
      st=IntList()
      st.int=6
      st.Next=substates
      substates=st
      # add substate "ALARM_STATUS.ENABLE"
      st=IntList()
      st.int=7
      st.Next=substates
      substates=st
    elif state==6: # substates of "ALARM_STATUS.DISABLE"
      pass
    elif state==7: # substates of "ALARM_STATUS.ENABLE"
      pass
    elif state==8: # substates of "BEEP_STATUS"
      # add substate "BEEP_STATUS.BEEPING_OFF"
      st=IntList()
      st.int=9
      st.Next=substates
      substates=st
      # add substate "BEEP_STATUS.BEEPING_ON"
      st=IntList()
      st.int=10
      st.Next=substates
      substates=st
    elif state==9: # substates of "BEEP_STATUS.BEEPING_OFF"
      pass
    elif state==10: # substates of "BEEP_STATUS.BEEPING_ON"
      pass
    elif state==11: # substates of "DISPLAY"
      # add substate "DISPLAY.ALARM"
      st=IntList()
      st.int=12
      st.Next=substates
      substates=st
      # add substate "DISPLAY.TIME"
      st=IntList()
      st.int=15
      st.Next=substates
      substates=st
      # add substate "DISPLAY.UPDATE_ALARM"
      st=IntList()
      st.int=16
      st.Next=substates
      substates=st
      # add substate "DISPLAY.UPDATE_TIME"
      st=IntList()
      st.int=19
      st.Next=substates
      substates=st
      # add substate "DISPLAY.WAIT"
      st=IntList()
      st.int=23
      st.Next=substates
      substates=st
    elif state==12: # substates of "DISPLAY.ALARM"
      # add substate "DISPLAY.ALARM.OFF"
      st=IntList()
      st.int=13
      st.Next=substates
      substates=st
      # add substate "DISPLAY.ALARM.ON"
      st=IntList()
      st.int=14
      st.Next=substates
      substates=st
    elif state==13: # substates of "DISPLAY.ALARM.OFF"
      pass
    elif state==14: # substates of "DISPLAY.ALARM.ON"
      pass
    elif state==15: # substates of "DISPLAY.TIME"
      pass
    elif state==16: # substates of "DISPLAY.UPDATE_ALARM"
      # add substate "DISPLAY.UPDATE_ALARM.ALARM_HR"
      st=IntList()
      st.int=17
      st.Next=substates
      substates=st
      # add substate "DISPLAY.UPDATE_ALARM.ALARM_MIN"
      st=IntList()
      st.int=18
      st.Next=substates
      substates=st
    elif state==17: # substates of "DISPLAY.UPDATE_ALARM.ALARM_HR"
      pass
    elif state==18: # substates of "DISPLAY.UPDATE_ALARM.ALARM_MIN"
      pass
    elif state==19: # substates of "DISPLAY.UPDATE_TIME"
      # add substate "DISPLAY.UPDATE_TIME.HR"
      st=IntList()
      st.int=20
      st.Next=substates
      substates=st
      # add substate "DISPLAY.UPDATE_TIME.MIN"
      st=IntList()
      st.int=21
      st.Next=substates
      substates=st
      # add substate "DISPLAY.UPDATE_TIME.SEC"
      st=IntList()
      st.int=22
      st.Next=substates
      substates=st
    elif state==20: # substates of "DISPLAY.UPDATE_TIME.HR"
      pass
    elif state==21: # substates of "DISPLAY.UPDATE_TIME.MIN"
      pass
    elif state==22: # substates of "DISPLAY.UPDATE_TIME.SEC"
      pass
    elif state==23: # substates of "DISPLAY.WAIT"
      pass
    elif state==24: # substates of "TIME_GEN"
      # add substate "TIME_GEN.TIME_GEN_OFF"
      st=IntList()
      st.int=25
      st.Next=substates
      substates=st
      # add substate "TIME_GEN.TIME_GEN_ON"
      st=IntList()
      st.int=26
      st.Next=substates
      substates=st
    elif state==25: # substates of "TIME_GEN.TIME_GEN_OFF"
      pass
    elif state==26: # substates of "TIME_GEN.TIME_GEN_ON"
      pass
    return substates

  def isHistoryState(self, state):

    return watchBehavior.HistoryStateTable[state]>0

  def isLeafState(self, state):

    if isinstance(state, int):
      return watchBehavior.LeafStateTable[state]!=None

    elif isinstance(state, str):
      for i in range(watchBehavior.StateNum):
        if watchBehavior.LeafStateTable[i]==None:
          continue
        if state==watchBehavior.LeafStateTable[i] and self.Submodels[i]==None:
          return 1
        elif startswith(state, watchBehavior.LeafStateTable[i]+".") and self.Submodels[i]!=None:
          SubmodelState=state[watchBehavior.LeafStateTable[i].length()+1:]
          return self.Submodels[i].isLeafState(SubmodelState)
    return 0

  def isHistoryUp2Date(self, state, time):

    for i in range(watchBehavior.StateNum):
      if self.history[state].Times[i]>=time:
        return 1
    return 0

  def mergeHistory(self, state, states, times):

    max=-1
    for i in range(watchBehavior.StateNum):
      if times[i]>max:
        max=times[i]
    if self.isHistoryUp2Date(state, max):
      for i in range(watchBehavior.StateNum):
        if times[i]>self.history[state].Times[i]:
          self.history[state].States[i]=states[i]
          self.history[state].Times[i]=times[i]
    else:
      self.history[state].States=copy.copy(states)
      self.history[state].Times=copy.copy(times)

  def recordHistory(self, top_state):

    curtime=time.time();
    s=self.state;
    while s!=None:
      child=s.StateID
      states=[]
      times=[]
      for i in range(watchBehavior.StateNum):
        states.append(-1)
        times.append(-1)
      states[child]=child
      times[child]=curtime
      if top_state<0 or self.isParent(top_state, child):
        parent=self.getParentState(child)
        if self.isHistoryState(child):
          self.history[child].Submodel=self.Submodels[child]
        while parent!=top_state and times[parent]!=curtime:
          states[parent]=child
          times[parent]=curtime
          if self.isHistoryState(parent):
            self.mergeHistory(parent, states, times)
          child=parent
          parent=self.getParentState(child)
      s=s.Next

  def hasHistoryRecorded(self, state):

    for i in range(watchBehavior.StateNum):
      if self.history[state].States[i]!=-1:
        return 1
      if self.Submodels[state]!=None:
        return 1
    return 0

  def hasOrthogonalStateInBetween(self, parent, leaf):

    return watchBehavior.OrthogonalInBetween[parent+1][leaf]

  def check_history(self, dest):

    s=self.state
    while s!=None:
      if self.isParent(dest, s.StateID) and not self.hasOrthogonalStateInBetween(dest, s.StateID):
        return 0
      s=s.Next
    return 1

  def getEnabledEvents(self):

    events=EventList()
    if self.isInState(7):
      events.Append("ALARM-OFF")
    if self.isInState(6):
      events.Append("ALARM-ON")
    if self.isInState(12):
      events.Append("A_PRESS")
    if self.isInState(15):
      events.Append("A_PRESS")
    if self.isInState(16):
      events.Append("B_PRESS")
    if self.isInState(4):
      events.Append("B_PRESS")
    if self.isInState(22):
      events.Append("C_PRESS")
    if self.isInState(21):
      events.Append("C_PRESS")
    if self.isInState(17):
      events.Append("C_PRESS")
    if self.isInState(12):
      events.Append("C_PRESS")
    if self.isInState(20):
      events.Append("C_PRESS")
    if self.isInState(15):
      events.Append("C_PRESS")
    if self.isInState(18):
      events.Append("C_PRESS")
    if self.isInState(23):
      events.Append("C_RELEASE")
    if self.isInState(22):
      events.Append("D_PRESS")
    if self.isInState(21):
      events.Append("D_PRESS")
    if self.isInState(20):
      events.Append("D_PRESS")
    if self.isInState(13):
      events.Append("D_PRESS")
    if self.isInState(14):
      events.Append("D_PRESS")
    if self.isInState(18):
      events.Append("D_PRESS")
    if self.isInState(17):
      events.Append("D_PRESS")
    if self.isInState(1):
      events.Append("RESET")
    if self.isInState(1):
      events.Append("RESET")
    if self.isInState(26):
      events.Append("TIME-OFF")
    if self.isInState(25):
      events.Append("TIME-ON")
    if self.isInState(10):
      events.Append("TURN_OFF")
    if self.isInState(9):
      events.Append("TURN_ON")
    if self.isInState(12):
      events.Append("__INTERNAL_0_TIME_0")
    if self.isInState(15):
      events.Append("__INTERNAL_0_TIME_1")
    if self.isInState(23):
      events.Append("__INTERNAL_0_TIME_2")
    if self.isInState(26):
      events.Append("__INTERNAL_0_TIME_3")
    if self.isInState(10):
      events.Append("__INTERNAL_0_TIME_4")
    if self.isInState(2):
      events.Append("__INTERNAL_0_TIME_5")
    if self.isInState(4):
      events.Append("__INTERNAL_0_TIME_6")
    return events.Next

  def getHierarchy(self, start_level, state_prefix):

    h=Hierarchy()
    lasth=h
    # Generate state "ALARM_BEEP" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ALARM_BEEP"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_BEEP"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_BEEP"
    lasth.Next.StateNum=0
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "ALARM_BEEP.BEEP" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEP"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_BEEP.BEEP"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_BEEP.BEEP"
    lasth.Next.StateNum=1
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "ALARM_BEEP.BEEP.BEEP_DELAY" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEP_DELAY"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_BEEP.BEEP.BEEP_DELAY"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_BEEP.BEEP.BEEP_DELAY"
    lasth.Next.StateNum=2
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "ALARM_BEEP.BEEP.BEEP_OFF" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEP_OFF"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_BEEP.BEEP.BEEP_OFF"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_BEEP.BEEP.BEEP_OFF"
    lasth.Next.StateNum=3
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "ALARM_BEEP.BEEP.BEEP_ON" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEP_ON"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_BEEP.BEEP.BEEP_ON"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_BEEP.BEEP.BEEP_ON"
    lasth.Next.StateNum=4
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "ALARM_STATUS" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ALARM_STATUS"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_STATUS"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_STATUS"
    lasth.Next.StateNum=5
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "ALARM_STATUS.DISABLE" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="DISABLE"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_STATUS.DISABLE"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_STATUS.DISABLE"
    lasth.Next.StateNum=6
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "ALARM_STATUS.ENABLE" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ENABLE"
    if state_prefix==None:
      lasth.Next.PathName="ALARM_STATUS.ENABLE"
    else:
      lasth.Next.PathName=state_prefix+".ALARM_STATUS.ENABLE"
    lasth.Next.StateNum=7
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "BEEP_STATUS" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEP_STATUS"
    if state_prefix==None:
      lasth.Next.PathName="BEEP_STATUS"
    else:
      lasth.Next.PathName=state_prefix+".BEEP_STATUS"
    lasth.Next.StateNum=8
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "BEEP_STATUS.BEEPING_OFF" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEPING_OFF"
    if state_prefix==None:
      lasth.Next.PathName="BEEP_STATUS.BEEPING_OFF"
    else:
      lasth.Next.PathName=state_prefix+".BEEP_STATUS.BEEPING_OFF"
    lasth.Next.StateNum=9
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "BEEP_STATUS.BEEPING_ON" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BEEPING_ON"
    if state_prefix==None:
      lasth.Next.PathName="BEEP_STATUS.BEEPING_ON"
    else:
      lasth.Next.PathName=state_prefix+".BEEP_STATUS.BEEPING_ON"
    lasth.Next.StateNum=10
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "DISPLAY" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="DISPLAY"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY"
    lasth.Next.StateNum=11
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "DISPLAY.ALARM" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ALARM"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.ALARM"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.ALARM"
    lasth.Next.StateNum=12
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "DISPLAY.ALARM.OFF" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="OFF"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.ALARM.OFF"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.ALARM.OFF"
    lasth.Next.StateNum=13
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.ALARM.ON" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ON"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.ALARM.ON"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.ALARM.ON"
    lasth.Next.StateNum=14
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.TIME" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="TIME"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.TIME"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.TIME"
    lasth.Next.StateNum=15
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_ALARM" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="UPDATE_ALARM"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_ALARM"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_ALARM"
    lasth.Next.StateNum=16
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_ALARM.ALARM_HR" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ALARM_HR"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_ALARM.ALARM_HR"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_ALARM.ALARM_HR"
    lasth.Next.StateNum=17
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_ALARM.ALARM_MIN" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="ALARM_MIN"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_ALARM.ALARM_MIN"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_ALARM.ALARM_MIN"
    lasth.Next.StateNum=18
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_TIME" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="UPDATE_TIME"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_TIME"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_TIME"
    lasth.Next.StateNum=19
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_TIME.HR" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="HR"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_TIME.HR"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_TIME.HR"
    lasth.Next.StateNum=20
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_TIME.MIN" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="MIN"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_TIME.MIN"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_TIME.MIN"
    lasth.Next.StateNum=21
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.UPDATE_TIME.SEC" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="SEC"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.UPDATE_TIME.SEC"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.UPDATE_TIME.SEC"
    lasth.Next.StateNum=22
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "DISPLAY.WAIT" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="WAIT"
    if state_prefix==None:
      lasth.Next.PathName="DISPLAY.WAIT"
    else:
      lasth.Next.PathName=state_prefix+".DISPLAY.WAIT"
    lasth.Next.StateNum=23
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "TIME_GEN" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="TIME_GEN"
    if state_prefix==None:
      lasth.Next.PathName="TIME_GEN"
    else:
      lasth.Next.PathName=state_prefix+".TIME_GEN"
    lasth.Next.StateNum=24
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "TIME_GEN.TIME_GEN_OFF" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="TIME_GEN_OFF"
    if state_prefix==None:
      lasth.Next.PathName="TIME_GEN.TIME_GEN_OFF"
    else:
      lasth.Next.PathName=state_prefix+".TIME_GEN.TIME_GEN_OFF"
    lasth.Next.StateNum=25
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "TIME_GEN.TIME_GEN_ON" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="TIME_GEN_ON"
    if state_prefix==None:
      lasth.Next.PathName="TIME_GEN.TIME_GEN_ON"
    else:
      lasth.Next.PathName=state_prefix+".TIME_GEN.TIME_GEN_ON"
    lasth.Next.StateNum=26
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    return h.Next

  def topLevelHistory(self):

    s=self.state.StateID
    t=self.getParentState(s)
    while t!=-1:
      s=t
      t=self.getParentState(s)
    self.changeState(s, s)

  def runActionCode(self, code_num):

    if code_num==0: # model finalizer
      pass
    elif code_num==1: # model initializer
      pass
    elif code_num==2: # output action(s) of a transition
      self.runCode("eventhandler.event(\"RESET\", [], None)")
      self.runCode("dump_message(\"BROADCAST RESET\")")
    elif code_num==3: # output action(s) of a transition
      self.runCode("eventhandler.event(\"TURN_OFF\", [], None)")
    elif code_num==4: # output action(s) of a transition
      self.runCode("eventhandler.event(\"RESET\", [], None)")
      self.runCode("eventhandler.event(\"TIME-ON\", [], None)")
      self.runCode("dump_message(\"BROADCAST RESET\")")
    elif code_num==5: # output action(s) of a transition
      self.runCode("helper.updateSec()")
    elif code_num==6: # output action(s) of a transition
      self.runCode("helper.updateMin()")
    elif code_num==7: # output action(s) of a transition
      self.runCode("helper.updateHr()")
    elif code_num==8: # output action(s) of a transition
      self.runCode("eventhandler.event(\"ALARM-ON\", [], None)")
    elif code_num==9: # output action(s) of a transition
      self.runCode("eventhandler.event(\"ALARM-OFF\", [], None)")
    elif code_num==10: # output action(s) of a transition
      self.runCode("helper.updateAlarmMin()")
    elif code_num==11: # output action(s) of a transition
      self.runCode("helper.updateAlarmHr()")
    elif code_num==12: # output action(s) of a transition
      self.runCode("helper.setAlarmDelay()")
    elif code_num==13: # output action(s) of a transition
      self.runCode("dump_message(\"TIME-OFF\")")
    elif code_num==14: # output action(s) of a transition
      self.runCode("dump_message(\"TIME-ON\")")
    elif code_num==15: # output action(s) of a transition
      self.runCode("print \"TURN_OFF\"")
    elif code_num==16: # output action(s) of a transition
      self.runCode("eventhandler.event(\"TIME-OFF\", None, None)")
    elif code_num==17: # output action(s) of a transition
      self.runCode("helper.updateCurrentTime()")
    elif code_num==18: # output action(s) of a transition
      self.runCode("dump_message(\"BEEP\")")
      self.runCode("proxy.beep()")
    elif code_num==19: # output action(s) of a transition
      self.runCode("eventhandler.event(\"TURN_ON\", [], None)")
    elif code_num==20: # output action(s) of a transition
      self.runCode("eventhandler.event(\"TURN_OFF\", [], None)")
    elif code_num==21: # enter actions for state "DISPLAY.UPDATE_TIME.HR"
      self.runCode("proxy.displayTime(helper.getCurrentTime())")
      self.runCode("print \"DISPLAY in UPDATE_TIME.HR\"")
    elif code_num==22: # enter actions for state "DISPLAY.ALARM"
      self.runCode("proxy.displayTime(helper.getCurrentTime())")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_0", eval("1", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[12]
      self.TimedTransitions[12]=sched
      sched.start()
    elif code_num==23: # enter actions for state "DISPLAY.ALARM.OFF"
      self.runCode("proxy.displayAlarmStatus(\"ALARM: OFF\")")
      self.runCode("print \"DISPLAY in ALARM.OFF\"")
    elif code_num==24: # enter actions for state "DISPLAY.UPDATE_TIME.MIN"
      self.runCode("proxy.displayTime(helper.getCurrentTime())")
      self.runCode("print \"DISPLAY in UPDATE_TIME.MIN\"")
    elif code_num==25: # enter actions for state "TIME_GEN.TIME_GEN_ON"
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_3", eval("1", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[26]
      self.TimedTransitions[26]=sched
      sched.start()
    elif code_num==26: # enter actions for state "ALARM_BEEP.BEEP.BEEP_OFF"
      self.runCode("print \"ALARM_BEEP in BEEP.BEEP_OFF\"")
    elif code_num==27: # enter actions for state "ALARM_BEEP.BEEP.BEEP_DELAY"
      self.runCode("print \"ALARM_BEEP in BEEP.BEEP_DELAY\"")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_5", eval("helper.getAlarmDelay()", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[2]
      self.TimedTransitions[2]=sched
      sched.start()
    elif code_num==28: # enter actions for state "DISPLAY.UPDATE_TIME.SEC"
      self.runCode("proxy.displayTime(helper.getCurrentTime())")
      self.runCode("print \"DISPLAY in UPDATE_TIME.SEC\"")
    elif code_num==29: # enter actions for state "DISPLAY.ALARM.ON"
      self.runCode("proxy.displayAlarmStatus(helper.getAlarmTime())")
      self.runCode("print \"DISPLAY in ALARM.ON\"")
    elif code_num==30: # enter actions for state "ALARM_BEEP.BEEP.BEEP_ON"
      self.runCode("print \"ALARM_BEEP in BEEP.BEEP_ON\"")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_6", eval("10", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[4]
      self.TimedTransitions[4]=sched
      sched.start()
    elif code_num==31: # enter actions for state "BEEP_STATUS.BEEPING_ON"
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_4", eval("1", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[10]
      self.TimedTransitions[10]=sched
      sched.start()
    elif code_num==32: # enter actions for state "DISPLAY.UPDATE_ALARM.ALARM_MIN"
      self.runCode("proxy.displayAlarmStatus(helper.getAlarmTime())")
      self.runCode("print \"DISPLAY in UPDATE_ALARM.ALARM_MIN\"")
    elif code_num==33: # enter actions for state "DISPLAY.WAIT"
      self.runCode("print \"DISPLAY in WAIT\"")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_2", eval("2", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[23]
      self.TimedTransitions[23]=sched
      sched.start()
    elif code_num==34: # enter actions for state "DISPLAY.UPDATE_ALARM.ALARM_HR"
      self.runCode("proxy.displayAlarmStatus(helper.getAlarmTime())")
      self.runCode("print \"DISPLAY in UPDATE_ALARM.ALARM_HR\"")
    elif code_num==35: # enter actions for state "DISPLAY.TIME"
      self.runCode("proxy.displayTime(helper.getCurrentTime())")
      self.runCode("print \"DISPLAY in TIME\"")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_1", eval("1", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[15]
      self.TimedTransitions[15]=sched
      sched.start()
    elif code_num==36: # exit actions for state "DISPLAY.ALARM"
      # clean up timed transitions
      if self.TimedTransitions[12]:
        self.TimedTransitions[12].clear()
        self.TimedTransitions[12]=None
    elif code_num==37: # exit actions for state "TIME_GEN.TIME_GEN_ON"
      # clean up timed transitions
      if self.TimedTransitions[26]:
        self.TimedTransitions[26].clear()
        self.TimedTransitions[26]=None
    elif code_num==38: # exit actions for state "ALARM_BEEP.BEEP.BEEP_DELAY"
      # clean up timed transitions
      if self.TimedTransitions[2]:
        self.TimedTransitions[2].clear()
        self.TimedTransitions[2]=None
    elif code_num==39: # exit actions for state "ALARM_BEEP.BEEP.BEEP_ON"
      # clean up timed transitions
      if self.TimedTransitions[4]:
        self.TimedTransitions[4].clear()
        self.TimedTransitions[4]=None
    elif code_num==40: # exit actions for state "BEEP_STATUS.BEEPING_ON"
      # clean up timed transitions
      if self.TimedTransitions[10]:
        self.TimedTransitions[10].clear()
        self.TimedTransitions[10]=None
    elif code_num==41: # exit actions for state "DISPLAY.WAIT"
      # clean up timed transitions
      if self.TimedTransitions[23]:
        self.TimedTransitions[23].clear()
        self.TimedTransitions[23]=None
    elif code_num==42: # exit actions for state "DISPLAY.TIME"
      # clean up timed transitions
      if self.TimedTransitions[15]:
        self.TimedTransitions[15].clear()
        self.TimedTransitions[15]=None

  def testCondition(self, cond_num):

    if cond_num==0 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==1 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==2 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==3 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==4 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==5 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==6 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==7 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==8 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==9 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==10 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==11 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==12 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==13 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==14 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==15 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==16 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==17 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==18 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==19 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==20 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==21 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(eventhandler.is_in_state(\"ALARM_STATUS.ENABLE\", 0))")==0 and self.TestResult:
      return 1
    elif cond_num==22 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(eventhandler.is_in_state(\"ALARM_STATUS.DISABLE\", 0))")==0 and self.TestResult:
      return 1
    elif cond_num==23 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==24 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==25 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==26 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==27 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==28 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==29 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==30 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==31 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==32 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    elif cond_num==33 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(1)")==0 and self.TestResult:
      return 1
    return 0

  def runEnterActions(self, state):

    if state==20: # enter action(s) for state "DISPLAY.UPDATE_TIME.HR"
      self.runActionCode(21)
    elif state==12: # enter action(s) for state "DISPLAY.ALARM"
      self.runActionCode(22)
    elif state==13: # enter action(s) for state "DISPLAY.ALARM.OFF"
      self.runActionCode(23)
    elif state==21: # enter action(s) for state "DISPLAY.UPDATE_TIME.MIN"
      self.runActionCode(24)
    elif state==26: # enter action(s) for state "TIME_GEN.TIME_GEN_ON"
      self.runActionCode(25)
    elif state==3: # enter action(s) for state "ALARM_BEEP.BEEP.BEEP_OFF"
      self.runActionCode(26)
    elif state==2: # enter action(s) for state "ALARM_BEEP.BEEP.BEEP_DELAY"
      self.runActionCode(27)
    elif state==22: # enter action(s) for state "DISPLAY.UPDATE_TIME.SEC"
      self.runActionCode(28)
    elif state==14: # enter action(s) for state "DISPLAY.ALARM.ON"
      self.runActionCode(29)
    elif state==4: # enter action(s) for state "ALARM_BEEP.BEEP.BEEP_ON"
      self.runActionCode(30)
    elif state==10: # enter action(s) for state "BEEP_STATUS.BEEPING_ON"
      self.runActionCode(31)
    elif state==18: # enter action(s) for state "DISPLAY.UPDATE_ALARM.ALARM_MIN"
      self.runActionCode(32)
    elif state==23: # enter action(s) for state "DISPLAY.WAIT"
      self.runActionCode(33)
    elif state==17: # enter action(s) for state "DISPLAY.UPDATE_ALARM.ALARM_HR"
      self.runActionCode(34)
    elif state==15: # enter action(s) for state "DISPLAY.TIME"
      self.runActionCode(35)

  def runExitActions(self, state):

    if state==12: # exit action(s) for state "DISPLAY.ALARM"
      self.runActionCode(36)
    elif state==26: # exit action(s) for state "TIME_GEN.TIME_GEN_ON"
      self.runActionCode(37)
    elif state==2: # exit action(s) for state "ALARM_BEEP.BEEP.BEEP_DELAY"
      self.runActionCode(38)
    elif state==4: # exit action(s) for state "ALARM_BEEP.BEEP.BEEP_ON"
      self.runActionCode(39)
    elif state==10: # exit action(s) for state "BEEP_STATUS.BEEPING_ON"
      self.runActionCode(40)
    elif state==23: # exit action(s) for state "DISPLAY.WAIT"
      self.runActionCode(41)
    elif state==15: # exit action(s) for state "DISPLAY.TIME"
      self.runActionCode(42)

  def recordAllEnteredStates(self):

    st=self.state
    while st!=None:
      self.recordEnteredState(st.StateID, 1, 1)
      st=st.Next

  def recordEnteredState(self, s, superstates=0, submodel=0, commonstate=-1):

    # test if s is already recorded
    se=self.StatesEntered
    found=0
    while se!=None:
      if se.int==s:
        found=1
        break
      se=se.Next

    if not found:
      if superstates:
        parent=self.getParentState(s)
        if parent>=0 and parent!=commonstate:
          self.recordEnteredState(parent, 1)
      st=IntList()
      st.Next=self.StatesEntered
      st.int=s
      self.StatesEntered=st
      if submodel and self.Submodels[s]:
        self.Submodels[s].recordAllEnteredStates()

  def runAllEnterActions(self):

    self.runEnterActionsForStates(self.StatesEntered, 1)

  def runEnterActionsForStates(self, states, recursive=0):

    if states:
      self.runEnterActionsForStates(states.Next, 0)
      self.runEnterActions(states.int)
    if recursive:
      for s in self.Submodels:
        if s:
          s.runAllEnterActions()

  def runExitActionsForStates(self, common_state):

    substates=self.getSubstates(common_state)
    if substates==None:
      s=self.state
      while s!=None and s.StateID!=common_state:
        s=s.Next
      if s!=None and self.Submodels[s.StateID]:
        self.Submodels[s.StateID].runExitActionsForStates(-1)
      return s!=None
    else:
      has_current_substate=0
      while substates!=None:
        res=self.runExitActionsForStates(substates.int)
        has_current_substate=has_current_substate or res
        if res:
          self.runExitActions(substates.int)
        substates=substates.Next
      return has_current_substate

  def runInitializer(self):

    self.runActionCode(1)
    for s in self.Submodels:
      if s:
        s.runInitializer()

  def runFinalizer(self):

    if self.Started:
      for s in self.Submodels:
        if s:
          s.runFinalizer()
      self.runActionCode(0)
      self.Started=0

  def clearEnteredStates(self):

    self.StatesEntered=None
    for s in self.Submodels:
      if s:
        s.clearEnteredStates()

  def runCode(self, c):

    if len(c)>0:
      l=""
      for i in string.split(c, "\n"):
        if len(l)==0:
          l=i
        elif string.find(i, " ")!=0 and not (string.find(i, "else")==0 and string.strip(i[4:])==":") and \
                               string.find(i, "elif ")!=0 and string.find(i, "elif\t")!=0 and \
                               not (string.find(i, "except")==0 and string.strip(i[6:])==":") and \
                               string.find(i, "except ")!=0 and string.find(i, "except\t")!=0:
          self.DefaultInterpreter.runsource(l+"\n")
          l=i
        else:
          l=l+"\n"+i
      if len(l)>0:
        self.DefaultInterpreter.runsource(l+"\n")

  def setupInterpreter(self):

    self.DefaultInterpreter.locals["eventhandler"]=self
    self.DefaultInterpreter.locals["dump_message"]=self.dump_message

  def checkPendingEvents(self):

    self.EventsLock.acquire()
    ev=self.PendingEvents
    if ev!=None:
      self.PendingEvents=ev.Next
      if self.PendingEvents==None:
        self.PendingEventsTail=None
      self.EventsLock.release()
      self.handleEvent(ev.Event[0], ev.Event[1], ev.Event[2], ev.Event[3])
    else:
      self.HandleEventRunning=0
      self.EventsLock.release()

  def get_event_params(self):

    return self.params

  def dump_message(self, msg):

    print msg

  def is_in_state(self, state, check_substate=0):

    i=0
    while i<watchBehavior.StateNum and watchBehavior.StateNames[i]!=state:
      i=i+1
    if i<watchBehavior.StateNum:
      return (not check_substate or self.isLeafState(i)) and self.isInState(i)
    else:
      return 0

  def start(self, lock=None, run_enter_actions=1):

    if run_enter_actions:
      self.runEnterActionsForStates(self.StatesEntered, 1)
    self.Started=1
    if run_enter_actions:
      self.checkPendingEvents()
    if lock:
      lock.release()

  def shutdown(self):

    pass

  def event(self, e, params=[], lock=None, call_submodels=1):

    self.EventsLock.acquire()
    running=self.HandleEventRunning
    if not running and self.Started:
      self.HandleEventRunning=1
    self.EventsLock.release()
    if not running and self.Started:
      thread.start_new_thread(self.handleEvent, (e, params, lock, call_submodels))
    else:
      self.EventsLock.acquire()
      ev=EventList()
      ev.Event=[e, params, lock, call_submodels]
      if self.PendingEventsTail!=None:
        self.PendingEventsTail.Next=ev
      else:
        self.PendingEvents=ev
      self.PendingEventsTail=ev
      self.EventsLock.release()


# main
if __name__=="__main__":
  watchBehavior().main(sys.argv)