# define the GUI of the QuartzWatch
# I re-use some code from Hans' TrafficLight example

from Tkinter import *
from Time import *
#from threading import Timer
import time

class watchGUI(Frame):

    def __init__(self, proxy, master=None, title="QuartzWatch"):
        
        self.bgColor = "yellow"
        self.alarm = StringVar()
        self.alarm.set("")
        self.display = StringVar()
        self.display.set("")

        self.proxy=proxy

        # Initialize superclass
        Frame.__init__(self, master)

        # parent frame, destruction protocol
        self.root=master
        self.root.protocol("WM_DELETE_WINDOW", self.wmQuit)

        # Initialize packer
        self.pack(fill=BOTH, expand=1)

        # Create all widgets in the Frame
        self.__createWidgets()

    

    def __createWidgets(self):

        self.root.configure(bg=self.bgColor)

        # put some empty space here
##        Label(self.root, text="", bg=self.bgColor,
##              height=2, width=10).pack(side=TOP, padx=2, pady=2)

        self.alarmLabel=Label(self.root, bg="white", fg="blue",
                         relief=GROOVE, height=2, width=10,
                         textvariable=self.alarm)
        self.alarmLabel.pack(side=TOP, padx=2, pady=4)
        
        self.displayLabel=Label(self.root, bg="white", fg="blue",
                                relief=GROOVE, height=2, width=10,
                                textvariable=self.display)
        self.displayLabel.pack(side=TOP, padx=2, pady=4)
        
##        Label(self.root, text="",bg=self.bgColor,
##              height=5, width=10).pack(side=TOP,padx=2,pady=2)
        
        self.aButton=Button(self.root, text="A",
                            command=self.A_Press,width=5,wraplength=70)
        self.aButton.pack(side=TOP, fill=Y, padx=5, pady = 2)
        
        self.bButton=Button(self.root, text="B",
                            command=self.B_Press,width=5,wraplength=70)
        self.bButton.pack(side=TOP, fill=Y, padx=5, pady = 2)
        
        self.cButton=Button(self.root, text="C",
                            width=5,wraplength=70)
        self.cButton.pack(side=TOP, fill=Y, padx=5, pady = 2)
        
        self.dButton=Button(self.root, text="D",
                            command=self.D_Press,width=5,wraplength=70)
        self.dButton.pack(side=TOP, fill=Y, padx=5, pady = 2)

        self.cButton.bind("<ButtonPress-1>", self.C_Press)
        self.cButton.bind("<ButtonRelease-1>", self.C_Release)

    # binding with proxy

    def A_Press(self):
        self.proxy.event("A_PRESS")

    def B_Press(self):
        self.proxy.event("B_PRESS")

    def C_Press(self, e):
        self.proxy.event("C_PRESS")

    def C_Release(self, e):
        self.proxy.event("C_RELEASE")

    def D_Press(self):
        self.proxy.event("D_PRESS")

    def wmQuit(self):
        self.root.destroy()

    def blink(self):
        self.displayLabel["bg"] = "red"
        #t = Timer(.4)
        #t.start()
        time.sleep(.4)
        self.displayLabel["bg"] = "white"

    def displayTime(self, t):
        self.display.set(str(t))

    def displayAlarmStatus(self, state):
        self.alarm.set(state)

        
        
    


        
