# __PNPlace.py_____________________________________________________
from ASGNode import *

from ATOM3Type import *

from ATOM3String import *
from ATOM3Integer import *
from graph_PNPlace import *
class PNPlace(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_PNPlace
      self.parent = parent
      self.name=ATOM3String('')
      self.keyword_= self.name
      self.tokens=ATOM3Integer(0)
      self.generatedAttributes = {'name': ('ATOM3String', ),
                                  'tokens': ('ATOM3Integer', )      }
   def show(self, parent, parentWindowInfo):
      ATOM3Type.show(self, parent, parentWindowInfo)
      self.containerFrame = Frame(parent)
      Label(self.containerFrame, text='name').grid(row=0,column=0,sticky=W)
      self.name.show(self.containerFrame, parentWindowInfo).grid(row=0,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'name', 0, 2)
      Label(self.containerFrame, text='tokens').grid(row=1,column=0,sticky=W)
      self.tokens.show(self.containerFrame, parentWindowInfo).grid(row=1,column=1,sticky=W)
      ASGNode.setGGAnyWidget (self, self.containerFrame, parentWindowInfo, 'tokens', 1, 2)
      ASGNode.editGGLabel(self, self.containerFrame, parentWindowInfo, 2)
      return self.containerFrame

   def toString(self, maxWide = None, maxLines = None ):
      rs = self.name.toString()+' '+self.tokens.toString()
      if maxWide: return self.strValue[0:maxWide-3]+'...'
      else: return rs


   def getValue(self):
      return (self.name.getValue(),self.tokens.getValue(),)

   def setValue(self, value):
      self.name.setValue(value[0])
      self.tokens.setValue(value[1])

   def writeConstructor2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the constructor and the value of the object. Must be overriden in children"
      self.name.writeConstructor2File(file, indent, objName+'.name', depth, generatingCode)
      self.tokens.writeConstructor2File(file, indent, objName+'.tokens', depth, generatingCode)

   def writeValue2File(self, file, indent, objName="at", depth = 0, generatingCode = 0):
      "Method that writes into a file the the value of the object. Must be overriden in children"
      self.name.writeValue2File(file, indent, objName+'.name', depth, generatingCode)
      self.tokens.writeValue2File(file, indent, objName+'.tokens', depth, generatingCode)

   def invalid(self):
      ASGNode.GGcheckSetNone(self)
      return self.name.invalid() or self.tokens.invalid() 

   def clone(self):
      cloneObject = PNPlace( self.parent )
      cloneObject.name = self.name.clone()
      cloneObject.tokens = self.tokens.clone()
      cloneObject.keyword_ = cloneObject.name
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      self.name = other.name
      self.tokens = other.tokens
      self.keyword_ = self.name
      ASGNode.copy(self, other)

   def destroy(self):
      ASGNode.GGcheckSetNone(self)
      self.name.destroy()
      self.tokens.destroy()
      self.containerFrame = None
   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None


